> ## Documentation Index
> Fetch the complete documentation index at: https://www.cockroachlabs.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create all PrivateEndpointServices for a cluster

> Can be used by the following roles assigned at the organization, folder or cluster scope:
- CLUSTER_ADMIN
- CLUSTER_OPERATOR_WRITER




## OpenAPI

````yaml /openapi/cloud/latest.json post /api/v1/clusters/{cluster_id}/networking/private-endpoint-services
openapi: 3.0.0
info:
  contact:
    email: support@cockroachlabs.com
    name: Cockroach Labs Support
    url: https://support.cockroachlabs.com
  description: An API for managing CockroachDB Cloud resources
  title: CockroachDB Cloud API
  version: '2024-09-16'
servers:
  - url: https://cockroachlabs.cloud
security:
  - Bearer: []
tags:
  - name: SCIM
  - name: Organizations
  - name: Clusters
  - name: Cluster Disruption
  - name: SQL Users
  - name: SQL Privilege Grants
  - name: Databases
  - name: Customer-managed Encryption Keys
  - name: Client CA Certificates
  - name: Cluster SSO
  - name: Log Export
  - name: Metric Export
  - name: Audit Logs
  - name: IP Allowlists
  - name: Egress Rules
  - name: Billing
  - name: Maintenance Windows
  - name: Blackout Windows
  - name: Role Management
  - name: Service Accounts
  - name: API Keys
  - name: Folders
  - name: Version Deferral
  - name: JWT Issuers
  - name: OpenID Connect Configuration
  - name: Private Endpoint Services
  - name: PCI
  - name: Physical Cluster Replication
  - name: Plan Migrations
  - name: Backup/Restore
  - name: Egress Private Endpoints
  - name: Multifactor Authentication
externalDocs:
  description: Use the CockroachDB Cloud API
  url: https://www.cockroachlabs.com/docs/cockroachcloud/cloud-api.html
paths:
  /api/v1/clusters/{cluster_id}/networking/private-endpoint-services:
    post:
      tags:
        - Private Endpoint Services
      summary: Create all PrivateEndpointServices for a cluster
      description: >
        Can be used by the following roles assigned at the organization, folder
        or cluster scope:

        - CLUSTER_ADMIN

        - CLUSTER_OPERATOR_WRITER
      operationId: CockroachCloud_CreatePrivateEndpointServices
      parameters:
        - name: cluster_id
          in: path
          description: cluster_id is the ID for the cluster.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PrivateEndpointServices'
        '400':
          description: Returned when a request field is invalid.
          content:
            application/json:
              schema: {}
        '401':
          description: Returned when the token bearer cannot be authenticated.
          content:
            application/json:
              schema: {}
        '403':
          description: >-
            Returned when the user does not have permission to access the
            resource.
          content:
            application/json:
              schema: {}
        '404':
          description: Returned when the resource does not exist.
          content:
            application/json:
              schema: {}
        '500':
          description: Server error
          content:
            application/json:
              schema: {}
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Status'
      x-codeSamples:
        - lang: curl
          source: |-
            curl --request POST \
              --url https://cockroachlabs.cloud/api/v1/clusters/{cluster_id}/networking/private-endpoint-services \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'
components:
  schemas:
    PrivateEndpointServices:
      type: object
      properties:
        services:
          description: services contains a list of all cluster related services.
          type: array
          items:
            $ref: '#/components/schemas/PrivateEndpointService'
      required:
        - services
    Status:
      type: object
      properties:
        code:
          format: int32
          type: integer
        details:
          type: array
          items:
            $ref: '#/components/schemas/Any'
        message:
          type: string
    PrivateEndpointService:
      type: object
      properties:
        availability_zone_ids:
          description: >-
            availability_zone_ids are the unique identifiers for the
            availability

            zones in which this service is available. Note these identifiers

            are unique even across typical cloud provider boundaries, for
            example

            AWS accounts or organizations. In AWS, availability zone ids for
            us-east-1

            are use1-az1, use1-az2, use1-az3.
          type: array
          items:
            type: string
        aws:
          $ref: '#/components/schemas/AWSPrivateLinkServiceDetail'
        cloud_provider:
          $ref: '#/components/schemas/CloudProvider.Type'
        endpoint_service_id:
          description: >-
            endpoint_service_id uniquely identifies this private endpoint
            service. This

            is the cloud provider generated id for the service.
          type: string
        name:
          description: name is the name of the private endpoints service.
          type: string
        region_name:
          description: region_name is the cloud provider region name (e.g. us-east-1).
          type: string
        status:
          $ref: '#/components/schemas/PrivateEndpointServiceStatus.Type'
      required:
        - region_name
        - cloud_provider
        - status
        - name
        - endpoint_service_id
        - availability_zone_ids
    Any:
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        In its binary encoding, an `Any` is an ordinary message; but in other
        wire

        forms like JSON, it has a special encoding. The format of the type URL
        is

        described on the `type_url` field.


        Protobuf APIs provide utilities to interact with `Any` values:


        - A 'pack' operation accepts a message and constructs a generic `Any`
        wrapper
          around it.
        - An 'unpack' operation reads the content of an `Any` message, either
        into an
          existing message or a new one. Unpack operations must check the type of the
          value they unpack against the declared `type_url`.
        - An 'is' operation decides whether an `Any` contains a message of the
        given
          type, i.e. whether it can 'unpack' that type.

        The JSON format representation of an `Any` follows one of these cases:


        - For types without special-cased JSON encodings, the JSON format
          representation of the `Any` is the same as that of the message, with an
          additional `@type` field which contains the type URL.
        - For types with special-cased JSON encodings (typically called
        'well-known'
          types, listed in https://protobuf.dev/programming-guides/json/#any), the
          JSON format representation has a key `@type` which contains the type URL
          and a key `value` which contains the JSON-serialized value.

        The text format representation of an `Any` is like a message with one
        field

        whose name is the type URL in brackets. For example, an `Any` containing
        a

        `foo.Bar` message may be written `[type.googleapis.com/foo.Bar] { a: 2
        }`.
      type: object
      properties:
        '@type':
          description: >-
            Identifies the type of the serialized Protobuf message with a URI
            reference

            consisting of a prefix ending in a slash and the fully-qualified
            type name.


            Example: type.googleapis.com/google.protobuf.StringValue


            This string must contain at least one `/` character, and the content
            after

            the last `/` must be the fully-qualified name of the type in
            canonical

            form, without a leading dot. Do not write a scheme on these URI
            references

            so that clients do not attempt to contact them.


            The prefix is arbitrary and Protobuf implementations are expected to

            simply strip off everything up to and including the last `/` to
            identify

            the type. `type.googleapis.com/` is a common default prefix that
            some

            legacy implementations require. This prefix does not indicate the
            origin of

            the type, and URIs containing it are not expected to respond to any

            requests.


            All type URL strings must be legal URI references with the
            additional

            restriction (for the text format) that the content of the reference

            must consist only of alphanumeric characters, percent-encoded
            escapes, and

            characters in the following set (not including the outer backticks):

            `/-.~_!$&()*+,;=`. Despite our allowing percent encodings,
            implementations

            should not unescape them to prevent confusion with existing parsers.
            For

            example, `type.googleapis.com%2FFoo` should be rejected.


            In the original design of `Any`, the possibility of launching a type

            resolution service at these type URLs was considered but Protobuf
            never

            implemented one and considers contacting these URLs to be
            problematic and

            a potential security issue. Do not attempt to contact type URLs.
          type: string
      additionalProperties: {}
    AWSPrivateLinkServiceDetail:
      type: object
      properties:
        availability_zone_ids:
          description: |-
            availability_zone_ids are the identifiers for the availability zones
            that the service is available in.
          type: array
          items:
            type: string
        service_id:
          description: |-
            service_id is the server side of the PrivateLink
            connection. This is the same as AWSPrivateLinkEndpoint.service_id.
          type: string
        service_name:
          description: >-
            service_name is the AWS service name customers use to create
            endpoints

            on their end.
          type: string
      required:
        - service_name
        - service_id
        - availability_zone_ids
    CloudProvider.Type:
      description: |2-
         - GCP: The Google Cloud Platform cloud provider.
         - AWS: The Amazon Web Services cloud provider.
         - AZURE: The Azure cloud provider.
      type: string
      enum:
        - GCP
        - AWS
        - AZURE
    PrivateEndpointServiceStatus.Type:
      type: string
      enum:
        - CREATING
        - AVAILABLE
        - CREATE_FAILED
        - DELETING
        - DELETE_FAILED
  securitySchemes:
    Bearer:
      type: http
      scheme: bearer

````